--[[ Raeli's Spell Announcement Addon main file ]]--
RSA = LibStub("AceAddon-3.0"):NewAddon("RSA", "AceConsole-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("RSA")
--RSA_Version = 0.91; -- NYI, Useless atm.

--[[ Some random variables. ]]--
local db
local pName = UnitName("player")



--[[ Default settings ]]--
local defaults = {
	global = {
	version = 0.0,
	},
	profile = {		
		channel = "MyCustomChannel",
		oldwheeldown = "",
		oldwheelup = "",
		pally = {
			HoF = {
				HoFW = true,
				HoFR = false,
				HoFC = true,
				HoFS = false,	
			},
			HoSac = {
				HoSacW = true,
				HoSacR = false,
				HoSacC = true,
				HoSacS = false,
			},
			HoSalv = {
				HoSalvW = true,
				HoSalvR = false,
				HoSalvC = true,
				HoSalvS = false,
			},
			HoP = {
				HoPW = true,
				HoPR = false,
				HoPC = true,
				HoPS = false,
			},
			DI = {--Divine Intervention
				DIW = true,
				DIR = true,
				DIC = false,
				DIS = false,
			},			
			DSac = {
				DSacR = true,
				DSacC = true,
				DSacS = false,
			},
			DP = {--Divine Protection
				DPR = true,
				DPC = false,
				DPS = false,
			},
			AM = {--Aura Mastery
				AMR = true,
				AMC = true,
				AMS = false,
			},			
			AD = {--Ardent Defender
				ADR = true,
				ADC = false,
				ADS = false,
			},			
			Forbearance = {
				--ForbearanceR = false,
				--ForbearanceC = false,
				ForbearanceS = true,
			},
			DPlea = {
				--DPleaR = false,
				--DPleaC = false,
				DPleaS = true,
			},
			RD = {--Righteous Defense
				RDR = true,
				RDS = false,
				RDC = false,
				RDResist = true,
				RDSuccess = true,
			},
			HoR = {--Hand of Reckoning
				HoRR = true,
				HoRS = false,
				HoRC = false,
				HoRResist = true,
				HoRSuccess = true,
			},
			RF = {--Righteous Fury
				RFPD = false,
				RFSW = false,
				RFOn = false,
			},
		},-- End Pally Section
		priest = {
			GS = {--Guardian Spirit
				GSW = true,
				GSR = true,
				GSC = false,
				GSS = false,
			},
			PS = {--Pain Suppression
				PSW = true,
				PSR = true,
				PSC = false,
				PSS = false,
			},
			PI = {--Power Infusion
				PIW = true,
				PIR = false,
				PIC = false,
				PIS = false,
			},
			FW = {--Fear Ward
				FWW = true,
				FWR = false,
				FWC = true,
				FWS = false,
			},
			DH = {--Divine Hymn
				--DHW = true,
				DHR = false,
				DHC = true,
				DHS = false,
			},
			HoH = {--Hymn of Hope
				--HoHW = true,
				HoHR = false,
				HoHC = true,
				HoHS = false,
			},			
		},-- End Priest Section


	
	},
}

--[[ Configuration Options ]]--
local options = {
    name = "Raeli's Spell Announcer",
    handler = RSA,
    type = 'group',
    args = {
		maindesc = {
		type = "description",
		name = "Configuration settings for Raeli's Spell Announcer.\n",
		},
		chansettings = {
			type = "group",
			name = "General Settings",
			args ={
				msghead = {
					type = "header",
					name = "Custom Channel Settings",
					order = 0,					
				},
				msddesc = {
					type = "description",
					name = "Here you can set your own custom channel. This allows you to announce spells in a channel of your choice.",
					order = 1,
				},
				msg = {
					type = "input",
					name = "Channel Name",
					usage = "[Channel Name]",
					order = 2,
					get = function(info)
							return RSA.db.profile.channel
						end,
					set = function(info, value)
							RSA.db.profile.channel = value
						end,
				},
			},
		},
		pally = {
			type = "group",
			name = "Paladin Spells",
			desc = "Announcement settings for Paladin Spells.",
			args = {
			
				RF = {
					type = "group",
					name = "Righteous Fury",
					desc = "Settings for Righteous Fury",
					args = {
						RFEnabled1 = {
							type = "header",
							name = "Tracking",
							order = 0,
						},
						RFEnabled2 = {
							type = "description",
							name = "This will track the Righteous Fury buff, if enabled it will warn you when it is not active.",
							order = 1,
						},
						RFEnabled3 = {
							type = "toggle",
							name = "On / Off",
							desc = "Check to turn on Righteous Fury detection.",
							order = 2,
							get = function(info) 
									return RSA.db.profile.pally.RF.RFOn
								  end,
							set = function (info, value)
									RSA.db.profile.pally.RF.RFOn = value
								  end,								
						},
						RF0 = {
							type = "header",
							name = "Protection Detection",
							order = 3,
							
						},
						RF1 = {
							type = "description",
							name = "This option allows you to choose if RSA will check for Righteous Fury in any spec or only when you are Protection.",
							order = 4,
						},
						RF2 = {
							type = "toggle",
							name = "On / Off",
							desc = "Check to turn on protection detection.",
							order = 5,
							get = function(info) 
									return RSA.db.profile.pally.RF.RFPD
								  end,
							set = function (info, value)
									RSA.db.profile.pally.RF.RFPD = value
								  end,								
						},
						RF3 = {
							type = "header",
							name = "Binding Settings",
							order = 6,
						},
						RF4 = {
							type = "description",
							name = "Here you can set if you want RSA to rebind your scroll wheel to cast Righteous Fury whenever it is not active. This functionality will not interfere with normal scroll wheel functionality.",
							order = 7,
						},
						RF5 = {
							type = "toggle",
							name = "Scroll Wheel Bind",
							order = 8,
							get = function(info) 
									return RSA.db.profile.pally.RF.RFSW
								  end,
							set = function (info, value)
									RSA.db.profile.pally.RF.RFSW = value
								  end,								
						},
					},
				},-- End of  #####
				
				RD = {
				type = "group",
				name = "Righteous Defense",
				desc = "Settings for Righteous Defense",
				args = {
						RD0 = {
							type = "header",
							name = "Channel Settings",
							order = 0,
						},
						RD1 = {
							type = "description",
							name = "Here you can ser which channels you want to send announcements to.",
							order = 1,
						},
						RDR = {
						type = "toggle",
						name = "Raid/Party",
						desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
						order = 3,
						get = function(info) 
								return RSA.db.profile.pally.RD.RDR
							  end,
						set = function (info, value)
								RSA.db.profile.pally.RD.RDR = value
							  end,	  
						},
						RDC = {
						type = "toggle",
						name = "Custom Channel",
						desc = "Announces in your custom channel.",
						order = 2,
						get = function(info) 
								return RSA.db.profile.pally.RD.RDC
							  end,
						set = function (info, value)
								RSA.db.profile.pally.RD.RDC = value
							  end,	  
						},
						RDS = {
						type = "toggle",
						name = "Self",
						desc = "Sends a local message to your default chat window that only you can see.",
						order = 4,
						get = function(info) 
								return RSA.db.profile.pally.RD.RDS
							  end,
						set = function (info, value)
								RSA.db.profile.pally.RD.RDS = value
							  end,	  
						},
						RD5 = {
							type = "header",
							name = "Announcement Settings",
							order = 5,
						},
						RD6 = {
							type = "description",
							name = "Here you can set if Righteous Defense announces upon successful taunt, or only taunt resists. \nNote that due to the fact that Righteous Defense can taunt up to three targets, you will announce for every mob that it afflicts. So you will potentially announce 3 times per Righteous Defense use.",
							order = 6,
						},
						RD7 = {
							type = "toggle",
							name = "Successful taunts",
							desc = "Check this to announce upon successful taunt.",
							order = 7,
							get = function(info) 
									return RSA.db.profile.pally.RD.RDSuccess
								  end,
							set = function (info, value)
									RSA.db.profile.pally.RD.RDSuccess = value
								  end,							
						},
						RD8 = {
							type = "toggle",
							name = "Resists",
							desc = "Check this to announce upon taunt resists.",
							order = 8,
							get = function(info) 
									return RSA.db.profile.pally.RD.RDResist
								  end,
							set = function (info, value)
									RSA.db.profile.pally.RD.RDResist = value
								  end,							
						},
					},
				},-- End of Righteous Defense #####
				
				HoR = {
					type = "group",
					name = "Hand of Reckoning",
					desc = "Settings for Hand of Reckoning",
					args = {
						HoR0 = {
							type = "header",
							name = "Channel Settings",
							order = 0,
						},
						HoR1 = {
							type = "description",
							name = "Here you can set which channels you want to send announcements to.",
							order = 1,
						},
						HoRR = {
							type = "toggle",
							name = "Raid/Party",
							desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
							order = 3,
							get = function(info) 
									return RSA.db.profile.pally.HoR.HoRR
								  end,
							set = function (info, value)
									RSA.db.profile.pally.HoR.HoRR = value
								  end,	  
						},
						HoRC = {
							type = "toggle",
							name = "Custom Channel",
							desc = "Announces in your custom channel.",
							order = 2,
							get = function(info) 
									return RSA.db.profile.pally.HoR.HoRC
								  end,
							set = function (info, value)
									RSA.db.profile.pally.HoR.HoRC = value
								  end,	  
						},
						HoRS = {
							type = "toggle",
							name = "Self",
							desc = "Sends a local message to your default chat window that only you can see.",
							order = 4,
							get = function(info) 
									return RSA.db.profile.pally.HoR.HoRS
								  end,
							set = function (info, value)
									RSA.db.profile.pally.HoR.HoRS = value
								  end,	  
						},
						HoR5 = {
							type = "header",
							name = "Announcement Settings",
							order = 5,
						},
						HoR6 = {
							type = "description",
							name = "Here you can set whether Hand of Reckoning announces on successful casts, resists, or both.",
							order = 6,
						},
						HoR7 = {
							type = "toggle",
							name = "Successful Taunts",
							desc = "Check this to announce upon successful taunt.",
							order = 7,
							get = function(info) 
									return RSA.db.profile.pally.HoR.HoRSuccess
								  end,
							set = function (info, value)
									RSA.db.profile.pally.HoR.HoRSuccess = value
								  end,	 							
						},
						HoR8 = {
							type = "toggle",
							name = "Resists",
							desc = "Check this to announce upon taunt resists.",
							order = 8,
							get = function(info) 
									return RSA.db.profile.pally.HoR.HoRResist
								  end,
							set = function (info, value)
									RSA.db.profile.pally.HoR.HoRResist = value
								  end,	 							
						},
						
					},
				},-- End of Hand of Reckoning #####
			
				DSac = {
					type = "group",
					name = "Divine Sacrifice",
					desc = "Channel settings for Divine Sacrifice",
					args = {
						DSacR = {
						type = "toggle",
						name = "Raid/Party",
						desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
						get = function(info) 
								return RSA.db.profile.pally.DSac.DSacR
							  end,
						set = function (info, value)
								RSA.db.profile.pally.DSac.DSacR = value
							  end,	  
						},
						DSacC = {
						type = "toggle",
						name = "Custom Channel",
						desc = "Announces in your custom channel.",
						get = function(info) 
								return RSA.db.profile.pally.DSac.DSacC
							  end,
						set = function (info, value)
								RSA.db.profile.pally.DSac.DSacC = value
							  end,	  
						},
						DSacS = {
						type = "toggle",
						name = "Self",
						desc = "Sends a local message to your default chat window that only you can see.",
						get = function(info) 
								return RSA.db.profile.pally.DSac.DSacS
							  end,
						set = function (info, value)
								RSA.db.profile.pally.DSac.DSacS = value
							  end,	  
						},
					},
				},-- End of Divine Sacrifice #####
				
				DP = {
				type = "group",
				name = "Divine Protection",
				desc = "Channel settings for Divine Protection",
				args = {
					DPR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.pally.DP.DPR
						  end,
					set = function (info, value)
							RSA.db.profile.pally.DP.DPR = value
						  end,	  
					},
					DPC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.pally.DP.DPC
						  end,
					set = function (info, value)
							RSA.db.profile.pally.DP.DPC = value
						  end,	  
					},
					DPS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.pally.DP.DPS
						  end,
					set = function (info, value)
							RSA.db.profile.pally.DP.DPS = value
						  end,	  
					},
				},
				},-- End of Divine Protection #####				
				
				HoF = {
				type = "group",
				name = "Hand of Freedom",
				desc = "Channel settings for Hand of Freedom",
				args = {
					HoFW = {
					type = "toggle",
					name = "Whisper",
					desc = "Whispers the target of your spell, unless the target is yourself.",
					get = function (info) 
							return RSA.db.profile.pally.HoF.HoFW
						  end,
						--get = "GetHoFW",  
					set = function (info, value)
							RSA.db.profile.pally.HoF.HoFW = value
						  end,
						
					},
					HoFR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.pally.HoF.HoFR
						  end,
					set = function (info, value)
							RSA.db.profile.pally.HoF.HoFR = value
						  end,	  
					},
					HoFC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.pally.HoF.HoFC
						  end,
					set = function (info, value)
							RSA.db.profile.pally.HoF.HoFC = value
						  end,	  
					},
					HoFS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.pally.HoF.HoFS
						  end,
					set = function (info, value)
							RSA.db.profile.pally.HoF.HoFS = value
						  end,	  
					},
				},
				},-- End of Hand of Freedom #####
				
				HoSac = {
				type = "group",
				name = "Hand of Sacrifice",
				desc = "Channel settings for Hand of Sacrifice",
				args = {
					HoSacW = {
					type = "toggle",
					name = "Whisper",
					desc = "Whispers the target of your spell, unless the target is yourself.",
					get = function (info) 
							return RSA.db.profile.pally.HoSac.HoSacW
						  end,
					set = function (info, value)
							RSA.db.profile.pally.HoSac.HoSacW = value
						  end,
						
					},
					HoSacR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.pally.HoSac.HoSacR
						  end,
					set = function (info, value)
							RSA.db.profile.pally.HoSac.HoSacR = value
						  end,	  
					},
					HoSacC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.pally.HoSac.HoSacC
						  end,
					set = function (info, value)
							RSA.db.profile.pally.HoSac.HoSacC = value
						  end,	  
					},
					HoSacS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.pally.HoSac.HoSacS
						  end,
					set = function (info, value)
							RSA.db.profile.pally.HoSac.HoSacS = value
						  end,	  
					},
				},
				},-- End of Hand of Sacrifice #####
				
				HoSalv = {
				type = "group",
				name = "Hand of Salvation",
				desc = "Channel settings for Hand of Salvation",
				args = {
					HoSalvW = {
					type = "toggle",
					name = "Whisper",
					desc = "Whispers the target of your spell, unless the target is yourself.",
					get = function (info) 
							return RSA.db.profile.pally.HoSalv.HoSalvW
						  end,
					set = function (info, value)
							RSA.db.profile.pally.HoSalv.HoSalvW = value
						  end,
						
					},
					HoSalvR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.pally.HoSalv.HoSalvR
						  end,
					set = function (info, value)
							RSA.db.profile.pally.HoSalv.HoSalvR = value
						  end,	  
					},
					HoSalvC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.pally.HoSalv.HoSalvC
						  end,
					set = function (info, value)
							RSA.db.profile.pally.HoSalv.HoSalvC = value
						  end,	  
					},
					HoSalvS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.pally.HoSalv.HoSalvS
						  end,
					set = function (info, value)
							RSA.db.profile.pally.HoSalv.HoSalvS = value
						  end,	  
					},
				},
				},-- End of Hand of Salvation #####
				
				HoP = {
				type = "group",
				name = "Hand of Protection",
				desc = "Channel settings for Hand of Protection",
				args = {
					HoPW = {
					type = "toggle",
					name = "Whisper",
					desc = "Whispers the target of your spell, unless the target is yourself.",
					get = function (info) 
							return RSA.db.profile.pally.HoP.HoPW
						  end,
					set = function (info, value)
							RSA.db.profile.pally.HoP.HoPW = value
						  end,
						
					},
					HoPR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.pally.HoP.HoPR
						  end,
					set = function (info, value)
							RSA.db.profile.pally.HoP.HoPR = value
						  end,	  
					},
					HoPC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.pally.HoP.HoPC
						  end,
					set = function (info, value)
							RSA.db.profile.pally.HoP.HoPC = value
						  end,	  
					},
					HoPS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.pally.HoP.HoPS
						  end,
					set = function (info, value)
							RSA.db.profile.pally.HoP.HoPS = value
						  end,
					},
				},
				},-- End of Hand of Protection #####
				
				DI = {
				type = "group",
				name = "Divine Intervention",
				desc = "Channel settings for Divine Intervention",
				args = {
					DIW = {
					type = "toggle",
					name = "Whisper",
					desc = "Whispers the target of your spell, unless the target is yourself.",
					get = function (info) 
							return RSA.db.profile.pally.DI.DIW
						  end,
					set = function (info, value)
							RSA.db.profile.pally.DI.DIW = value
						  end,
						
					},
					DIR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.pally.DI.DIR
						  end,
					set = function (info, value)
							RSA.db.profile.pally.DI.DIR = value
						  end,	  
					},
					DIC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.pally.DI.DIC
						  end,
					set = function (info, value)
							RSA.db.profile.pally.DI.DIC = value
						  end,	  
					},
					DIS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.pally.DI.DIS
						  end,
					set = function (info, value)
							RSA.db.profile.pally.DI.DIS = value
						  end,
					},
				},
				},-- End of Divine Intervention #####
				
				Forbearance = {
				type = "group",
				name = "Forbearance",
				desc = "Channel settings for Forbearance",
				args = {
					--[[ForbearanceR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.pally.Forbearance.ForbearanceR
						  end,
					set = function (info, value)
							RSA.db.profile.pally.Forbearance.ForbearanceR = value
						  end,	  
					},
					ForbearanceC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.pally.Forbearance.ForbearanceC
						  end,
					set = function (info, value)
							RSA.db.profile.pally.Forbearance.ForbearanceC = value
						  end,	  
					},]]-- -- Why would we want to announce Forbearance at all except to ourselves?
					ForbearanceS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.pally.Forbearance.ForbearanceS
						  end,
					set = function (info, value)
							RSA.db.profile.pally.Forbearance.ForbearanceS = value
						  end,
					},
				},
				},-- End of Forbearance #####
				
				DPlea = {
				type = "group",
				name = "Divine Plea",
				desc = "Channel settings for Divine Plea",
				args = {
					--[[DPleaR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.pally.DPlea.DPleaR
						  end,
					set = function (info, value)
							RSA.db.profile.pally.DPlea.DPleaR = value
						  end,	  
					},
					DPleaC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.pally.DPlea.DPleaC
						  end,
					set = function (info, value)
							RSA.db.profile.pally.DPlea.DPleaC = value
						  end,	  
					},]]-- -- Why would we want to announce Divine Plea at all except to ourselves?
					DPleaS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.pally.DPlea.DPleaS
						  end,
					set = function (info, value)
							RSA.db.profile.pally.DPlea.DPleaS = value
						  end,
					},
				},
				},-- End of DPlea #####

				AD = {
				type = "group",
				name = "Ardent Defender",
				desc = "Channel settings for Ardent Defender",
				args = {
					ADR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.pally.AD.ADR
						  end,
					set = function (info, value)
							RSA.db.profile.pally.AD.ADR = value
						  end,	  
					},
					ADC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.pally.AD.ADC
						  end,
					set = function (info, value)
							RSA.db.profile.pally.AD.ADC = value
						  end,	  
					},
					ADS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.pally.AD.ADS
						  end,
					set = function (info, value)
							RSA.db.profile.pally.AD.ADS = value
						  end,	  
					},
				},
				},-- End of Ardent Defender #####
				
				AM = {
				type = "group",
				name = "Aura Mastery",
				desc = "Channel settings for Aura Mastery",
				args = {
					AMR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.pally.AM.AMR
						  end,
					set = function (info, value)
							RSA.db.profile.pally.AM.AMR = value
						  end,	  
					},
					AMC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.pally.AM.AMC
						  end,
					set = function (info, value)
							RSA.db.profile.pally.AM.AMC = value
						  end,	  
					},
					AMS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.pally.AM.AMS
						  end,
					set = function (info, value)
							RSA.db.profile.pally.AM.AMS = value
						  end,	  
					},
				},
				},-- End of Aura Mastery #####
				
			},-- End of pally group args
		},-- End of Pally section.
--[[		
		priest = {
			type = "group",
			name = "Priest Spells",
			desc = "Announcement settings for Priest Spells.",
			args = {

				GS = {
				type = "group",
				name = "Guardian Spirit",
				desc = "Channel settings for Guardian Spirit",
				args = {
					GSW = {
					type = "toggle",
					name = "Whisper",
					desc = "Whispers the target of your spell, unless the target is yourself.",
					get = function (info) 
							return RSA.db.profile.priest.GS.GSW
						  end,
					set = function (info, value)
							RSA.db.profile.priest.GS.GSW = value
						  end,						
					},				
					GSR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.priest.GS.GSR
						  end,
					set = function (info, value)
							RSA.db.profile.priest.GS.GSR = value
						  end,	  
					},
					GSC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.priest.GS.GSC
						  end,
					set = function (info, value)
							RSA.db.profile.priest.GS.GSC = value
						  end,	  
					},
					GSS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.priest.GS.GSS
						  end,
					set = function (info, value)
							RSA.db.profile.priest.GS.GSS = value
						  end,	  
					},
				},
				},-- End of Guardian Spirit #####
				
				PS = {
				type = "group",
				name = "Pain Suppression",
				desc = "Channel settings for Pain Suppression",
				args = {
					PSW = {
					type = "toggle",
					name = "Whisper",
					desc = "Whispers the target of your spell, unless the target is yourself.",
					get = function (info) 
							return RSA.db.profile.priest.PS.PSW
						  end,
						--get = "GetPSW",  
					set = function (info, value)
							RSA.db.profile.priest.PS.PSW = value
						  end,
						
					},				
					PSR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.priest.PS.PSR
						  end,
					set = function (info, value)
							RSA.db.profile.priest.PS.PSR = value
						  end,	  
					},
					PSC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.priest.PS.PSC
						  end,
					set = function (info, value)
							RSA.db.profile.priest.PS.PSC = value
						  end,	  
					},
					PSS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.priest.PS.PSS
						  end,
					set = function (info, value)
							RSA.db.profile.priest.PS.PSS = value
						  end,	  
					},
				},
				},-- End of Pain Suppression #####
				
				PI = {
				type = "group",
				name = "Power Infusion",
				desc = "Channel settings for Power Infusion",
				args = {
					PIW = {
					type = "toggle",
					name = "Whisper",
					desc = "Whispers the target of your spell, unless the target is yourself.",
					get = function (info) 
							return RSA.db.profile.priest.PI.PIW
						  end,
					set = function (info, value)
							RSA.db.profile.priest.PI.PIW = value
						  end,
						
					},
					PIR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.priest.PI.PIR
						  end,
					set = function (info, value)
							RSA.db.profile.priest.PI.PIR = value
						  end,	  
					},
					PIC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.priest.PI.PIC
						  end,
					set = function (info, value)
							RSA.db.profile.priest.PI.PIC = value
						  end,	  
					},
					PIS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.priest.PI.PIS
						  end,
					set = function (info, value)
							RSA.db.profile.priest.PI.PIS = value
						  end,	  
					},
				},
				},-- End of Power Infusion #####
				
				FW = {
				type = "group",
				name = "Fear Ward",
				desc = "Channel settings for Fear Ward",
				args = {
					FWW = {
					type = "toggle",
					name = "Whisper",
					desc = "Whispers the target of your spell, unless the target is yourself.",
					get = function (info) 
							return RSA.db.profile.priest.FW.FWW
						  end,
					set = function (info, value)
							RSA.db.profile.priest.FW.FWW = value
						  end,
						
					},
					FWR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.priest.FW.FWR
						  end,
					set = function (info, value)
							RSA.db.profile.priest.FW.FWR = value
						  end,	  
					},
					FWC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.priest.FW.FWC
						  end,
					set = function (info, value)
							RSA.db.profile.priest.FW.FWC = value
						  end,	  
					},
					FWS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.priest.FW.FWS
						  end,
					set = function (info, value)
							RSA.db.profile.priest.FW.FWS = value
						  end,	  
					},
				},
				},-- End of Fear Ward #####

				DH = {
				type = "group",
				name = "Divine Hymn",
				desc = "Channel settings for Divine Hymn",
				args = {
					DHR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.priest.DH.DHR
						  end,
					set = function (info, value)
							RSA.db.profile.priest.DH.DHR = value
						  end,	  
					},
					DHC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.priest.DH.DHC
						  end,
					set = function (info, value)
							RSA.db.profile.priest.DH.DHC = value
						  end,	  
					},
					DHS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.priest.DH.DHS
						  end,
					set = function (info, value)
							RSA.db.profile.priest.DH.DHS = value
						  end,	  
					},
				},
				},-- End of Divine Hymn #####
				
				HoH = {
				type = "group",
				name = "Hymn of Hope",
				desc = "Channel settings for Hymn of Hope",
				args = {
					HoHR = {
					type = "toggle",
					name = "Raid/Party",
					desc = "Announces in raid if you're in a raid, party if you're only in a party, or not at all if you're ungrouped.",
					get = function(info) 
							return RSA.db.profile.priest.HoH.HoHR
						  end,
					set = function (info, value)
							RSA.db.profile.priest.HoH.HoHR = value
						  end,	  
					},
					HoHC = {
					type = "toggle",
					name = "Custom Channel",
					desc = "Announces in your custom channel.",
					get = function(info) 
							return RSA.db.profile.priest.HoH.HoHC
						  end,
					set = function (info, value)
							RSA.db.profile.priest.HoH.HoHC = value
						  end,	  
					},
					HoHS = {
					type = "toggle",
					name = "Self",
					desc = "Sends a local message to your default chat window that only you can see.",
					get = function(info) 
							return RSA.db.profile.priest.HoH.HoHS
						  end,
					set = function (info, value)
							RSA.db.profile.priest.HoH.HoHS = value
						  end,	  
					},
				},
				},-- End of Hymn of Hope #####
			
			
			
			},--End of priest group args
		},-- End of priest section.
		
	]]--	
    },-- End of main options args	
}-- End of Options



--[[ Ace functions ]]--
function RSA:OnInitialize()
    -- Called when the addon is loaded
    self.db = LibStub("AceDB-3.0"):New("RSADB", defaults)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("RSA", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("RSA", "RSA")
    self:RegisterChatCommand("RSA", "ChatCommand")	
	
	-- We might have to use this if the addon has substantial changes.
	--[[if self.db.global.version < RSA_Version then
		Print_Self("Addon has been updated. Resetting default data.");
		self.db.global.version = RSA_Version
		-- Then do the shit to reset values.
	end]]--


	

end

function RSA:OnProfileEnable()
	self.db = self.db.profile
end

function RSA:ChatCommand(input)
--   if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
--    else
--        LibStub("AceConfigCmd-3.0").HandleCommand(RSA, "RSA", input)
--    end
end






--[[ Announcement functions]]--
function Print_Self(message) -- Sends a message to your default chat window.
	_G.ChatFrame1:AddMessage("|cFFFF75B3RSA:|r " .. format(message, spellinfo))
end

function Print_Raid(message) -- Sends a message to the raid if you're in a raid, or a party if you're in a party or nothing if you aren't in either.
	if GetNumRaidMembers()>0 then
		SendChatMessage(format(message, spellinfo), "RAID", nil)
	elseif GetNumPartyMembers()>0 then
		SendChatMessage(format(message, spellinfo), "PARTY", nil)
end
end

function Print_Channel(message) -- Sends a message to the custom channel that the user defines.
	if GetNumRaidMembers()>0 or GetNumPartyMembers()>0 then
		SendChatMessage(format(message, spellinfo), "CHANNEL", nil, GetChannelName(RSA.db.profile.channel))
	end
end

function Print_Self_RW(message) -- Sends a message locally to the raid warning frame. Only visible to the user.
	local RWColor = {r=1, g=1, b=1}
	RaidNotice_AddMessage(RaidWarningFrame, "|cFFFF75B3RSA:|r " .. format(message, spellinfo), RWColor)
end

function Print_RW(message) -- Sends a proper message to the raid warning frame. 
	SendChatMessage(format(message, spellinfo), "RAID_WARNING", nil)
end

function Print_Whisper(message, target) -- Sends a whisper to the target.
	SendChatMessage(format(message, spellinfo), "WHISPER", nil, target)
end



--[[ Detect what talent spec we are. ]]--
local numTalents, maxTemp, returnIndex
local tempTable = {}
function GetPrimarySpecInfo()
   numTalents = 0
   tempTable = wipe(tempTable)
   local name, iconTexture, pointsSpent, background
   local level = UnitLevel("player");
   local hasSpec = not ( level > 0 and level < 10 )
   for i = 1, GetNumTalentTabs() do
      name, iconTexture, pointsSpent, background = GetTalentTabInfo(i)
      if numTalents <= pointsSpent then
         numTalents = pointsSpent
         tempTable[i] = {name, iconTexture, pointsSpent, background}
         returnIndex = i
      end
   end
   -- returns name, iconTexture, pointsSpent, background
   if hasSpec then
      return tempTable[returnIndex][1] -- Spec Name
	  --, tempTable[returnIndex][2], tempTable[returnIndex][3], tempTable[returnIndex][4]
   end
end
-- suggested usage
--Print_Self(GetPrimarySpecInfo(player))



--[[ Righteous Fury Reminder Warning Section ]]--
local RFWarner = CreateFrame("Frame", "RFWarnerFrame");
local value1 = 15.0
local totalElapsed = 0.0;
local function RFWarning(self, elapsed) -- Send the message that Righteous Fury is missing.
		totalElapsed = totalElapsed + elapsed
		if totalElapsed < value1 then 
			return; 
		end
		totalElapsed = totalElapsed - floor(totalElapsed)
		if RSA.db.profile.pally.RF.RFOn == true then
			Print_Self("Righteous Fury Missing!")
		end	
end
--[[ Monitor Missing Buffs ]]--
local rebuffer = CreateFrame("Frame", "RSA_MONITOR");
local function rebuffhandler(arg1, arg2, arg3, arg4)
	if (RSA.db.profile.pally.RF.RFPD == true and GetPrimarySpecInfo(player) == "Protection" and RSA.db.profile.pally.RF.RFOn == true)
	or ( RSA.db.profile.pally.RF.RFPD == false and RSA.db.profile.pally.RF.RFOn == true) then -- Check for Protection Detection for Righteous Fury
		if arg3 == 'player' then
		name, rank, icon, count, debuffType, duration, expirationTime, source, isStealable = UnitBuff("player", "Righteous Fury")
			if name ~= "Righteous Fury" then
				bindingcheck()
				RFWarner:SetScript("OnUpdate", RFWarning)
				incombat = UnitAffectingCombat("player")
				playerdead = UnitIsDeadOrGhost("player")
				if incombat ~= 1 and playerdead ~= 1 and RSA.db.profile.pally.RF.RFSW == true then
						SetBindingSpell("MOUSEWHEELUP", "Righteous Fury")
						SetBindingSpell("MOUSEWHEELDOWN", "Righteous Fury")
					--Print_Self("yay")
				elseif playerdead == 1 and RSA.db.profile.pally.RF.RFSW == true then
					--Print_Self("nay")
						SetBinding("MOUSEWHEELUP", RSA.db.profile.oldwheelup)
						SetBinding("MOUSEWHEELDOWN", RSA.db.profile.oldwheeldown)						
					end
			elseif name == "Righteous Fury" and RSA.db.profile.pally.RF.RFSW == true then
				--Print_Self("why")
				SetBinding("MOUSEWHEELUP", RSA.db.profile.oldwheelup)
				SetBinding("MOUSEWHEELDOWN", RSA.db.profile.oldwheeldown)
			end	
		end
	elseif RSA.db.profile.pally.RF.RFPD == true and GetPrimarySpecInfo(player) ~="Protection" and RSA.db.profile.pally.RF.RFOn == true then
		RFWarner:SetScript("OnUpdate", nil)
		SetBinding("MOUSEWHEELUP", RSA.db.profile.oldwheelup)
		SetBinding("MOUSEWHEELDOWN", RSA.db.profile.oldwheeldown)		
	end	
end
rebuffer:SetScript("OnEvent", rebuffhandler);
rebuffer:RegisterEvent("UNIT_AURA");

function bindingcheck() -- Check what our old key binds were for Mouse Wheel Up and Down. We must do this before rebinding.
	local i;
	for i = 1, GetNumBindings(), 1 do
		local command, key1 = GetBinding(i);
		if (key1 == "MOUSEWHEELUP" and command ~= "SPELL") then
			RSA.db.profile.oldwheelup = command
			--print("Old Wheel Up: " .. command)
		elseif (key1 == "MOUSEWHEELDOWN" and command ~= "SPELL") then
			RSA.db.profile.oldwheeldown = command
			--print("Old Wheel Down: " .. command)
		end
	end
end



--[[ The event checking section. Look for our spells! ]]--
local spells = CreateFrame("Frame", "RSA_SPELLS")
spells:SetScript("OnEvent", function(_, _, _, event, _, source, _, _, dest, _, spellID, _, _, missType)
	if source == pName then	
		if event == "SPELL_CAST_SUCCESS" then -- Start event check for spells that have actually been cast.
		
			--[[ Start Paladin Spells ]]--
			if spellID == 64205 then -- Divine Sacrifice
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.pally.DSac.DSacR == true then
					Print_Raid("%s activated!")
				end
				if RSA.db.profile.pally.DSac.DSacC == true then
					Print_Channel("%s activated!")
				end
				if RSA.db.profile.pally.DSac.DSacS == true then
					Print_Self("%s activated!")
				end
			end
			
			if spellID == 498 then -- Divine Protection
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.pally.DP.DPR == true then
					Print_Raid("%s activated!")
				end
				if RSA.db.profile.pally.DP.DPC == true then
					Print_Channel("%s activated!")
				end
				if RSA.db.profile.pally.DP.DPS == true then
					Print_Self("%s activated!")
				end
			end
			
			if spellID == 1022 or spellID == 5599 or spellID == 10278 then -- Hand of Protection
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.pally.HoP.HoPR == true then
					Print_Raid("%s on " .. dest .. "!")
				end
				if RSA.db.profile.pally.HoP.HoPC == true then
					Print_Channel("%s on " .. dest .. "!")
				end
				if RSA.db.profile.pally.HoP.HoPS == true then
					Print_Self("%s on " .. dest .. "!")
				end
				if RSA.db.profile.pally.HoP.HoPW == true and dest ~= pName then
					Print_Whisper("%s on You!", dest)
				end	
			end
			
			if spellID == 6940 then -- Hand of Sacrifice
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.pally.HoSac.HoSacR == true then
					Print_Raid("%s on " .. dest .. "!")
				end
				if RSA.db.profile.pally.HoSac.HoSacC == true then
					Print_Channel("%s on " .. dest .. "!")
				end
				if RSA.db.profile.pally.HoSac.HoSacS == true then
					Print_Self("%s on " .. dest .. "!")
				end
				if RSA.db.profile.pally.HoSac.HoSacW == true and dest ~= pName then
					Print_Whisper("%s on You!", dest)
				end	
			end
			
			if spellID == 1038 then -- Hand of Salvation
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.pally.HoSalv.HoSalvR == true then
					Print_Raid("%s on " .. dest .. "!")
				end
				if RSA.db.profile.pally.HoSalv.HoSalvC == true then
					Print_Channel("%s on " .. dest .. "!")
				end
				if RSA.db.profile.pally.HoSalv.HoSalvS == true then
					Print_Self("%s on " .. dest .. "!")
				end
				if RSA.db.profile.pally.HoSalv.HoSalvW == true and dest ~= pName then
					Print_Whisper("%s on You!", dest)
				end	
			end
			
			if spellID == 1044 then -- Hand of Freedom
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.pally.HoF.HoFR == true then
					Print_Raid("%s on " .. dest .. "!")
				end
				if RSA.db.profile.pally.HoF.HoFC == true then
					Print_Channel("%s on " .. dest .. "!")
				end
				if RSA.db.profile.pally.HoF.HoFS == true then
					Print_Self("%s on " .. dest .. "!")
				end
				if RSA.db.profile.pally.HoF.HoFW == true and dest ~= pName then
					Print_Whisper("%s on You!", dest)
				end	
			end
			
			if spellID == 19752 then -- Divine Intervention
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.pally.DI.DIR == true then
					Print_Raid("%s on " .. dest .. "!")
				end
				if RSA.db.profile.pally.DI.DIC == true then
					Print_Channel("%s on " .. dest .. "!")
				end
				if RSA.db.profile.pally.DI.DIS == true then
					Print_Self("%s on " .. dest .. "!")
				end
				if RSA.db.profile.pally.DI.DIW == true and dest ~= pName then
					Print_Whisper("%s on You!", dest)
				end	
			end
			
			if spellID == 31821 then -- Aura Mastery	
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.pally.AM.AMR == true then
					Print_Raid("%s activated!")
				end
				if RSA.db.profile.pally.AM.AMC == true then
					Print_Channel("%s activated!")
				end
				if RSA.db.profile.pally.AM.AMS == true then
					Print_Self("%s activated!")
				end
			end			
			
			--[[ Start Priest Spells ]]-- 
--[[			if spellID == 10060 then -- Power Infusion
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.priest.PI.PIR == true then
					Print_Raid("%s on " .. dest .. "!")
				end
				if RSA.db.profile.priest.PI.PIC == true then
					Print_Channel("%s on " .. dest .. "!")
				end
				if RSA.db.profile.priest.PI.PIS == true then
					Print_Self("%s on " .. dest .. "!")
				end
				if RSA.db.profile.priest.PI.PIW == true and dest ~= pName then
					Print_Whisper("%s on You!", dest)
				end	
			end
			
			if spellID == 6346 then -- Fear Ward
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.priest.FW.FWR == true then
					Print_Raid("%s on " .. dest .. "!")
				end
				if RSA.db.profile.priest.FW.FWC == true then
					Print_Channel("%s on " .. dest .. "!")
				end
				if RSA.db.profile.priest.FW.FWS == true then
					Print_Self("%s on " .. dest .. "!")
				end
				if RSA.db.profile.priest.FW.FWW == true and dest ~= pName then
					Print_Whisper("%s on You!", dest)
				end	
			end
			
			if spellID == 64843 then -- Divine Hymn
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.priest.DH.DHR == true then
					Print_Raid("%s activated!")
				end
				if RSA.db.profile.priest.DH.DHC == true then
					Print_Channel("%s activated!")
				end
				if RSA.db.profile.priest.DH.DHS == true then
					Print_Self("%s activated!")
				end
			end
			
			if spellID == 64901 then -- Hymn of Hope
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.priest.HoH.HoHR == true then
					Print_Raid("%s activated!")
				end
				if RSA.db.profile.priest.HoH.HoHC == true then
					Print_Channel("%s activated!")
				end
				if RSA.db.profile.priest.HoH.HoHS == true then
					Print_Self("%s activated!")
				end
			end
			
		]]--
		
		elseif event == "SPELL_AURA_REMOVED" then -- Start event check for spells that are ending. We don't want to monitor every spell ending though.
		
			--[[ Start Paladin Spells ]]--
			if spellID == 64205 and dest == pName then -- Divine Sacrifice
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.pally.DSac.DSacR == true then
					Print_Raid("%s has ended!")
				end
				if RSA.db.profile.pally.DSac.DSacC == true then
					Print_Channel("%s has ended!")
				end
				if RSA.db.profile.pally.DSac.DSacS == true then
					Print_Self("%s has ended!")
				end		
			end
			
			if spellID == 498 and dest == pName then -- Divine Protection
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.pally.DP.DPR == true then
					Print_Raid("%s has ended!")
				end
				if RSA.db.profile.pally.DP.DPC == true then
					Print_Channel("%s has ended!")
				end
				if RSA.db.profile.pally.DP.DPS == true then
					Print_Self("%s has ended!")
				end		
			end
			
			if spellID == 25771 and dest == pName then -- Forbearance
				spellinfo = GetSpellInfo(spellID)
				--[[if RSA.db.profile.pally.Forbearance.ForbearanceR == true then
					Print_Raid("%s has ended!")
				end
				if RSA.db.profile.pally.Forbearance.ForbearanceC == true then
					Print_Channel("%s has ended!")
				end]]-- -- We don't need to run this check as the options for announcing in these places has been disabled.
				if RSA.db.profile.pally.Forbearance.ForbearanceS == true then
					Print_Self("%s has ended!")
				end		
			end
			
			if spellID == 54428 and dest == pName then -- Divine Plea
				spellinfo = GetSpellInfo(spellID)
				--[[if RSA.db.profile.pally.DPlea.DPleaR == true then
					Print_Raid("%s has ended!")
				end
				if RSA.db.profile.pally.DPlea.DPleaC == true then
					Print_Channel("%s has ended!")
				end]]-- -- We don't need to run this check as the options for announcing in these places has been disabled.
				if RSA.db.profile.pally.DPlea.DPleaS == true then
					Print_Self("%s has ended!")
				end		
			end

			if spellID == 66233 and dest == pName then -- Ardent Defender
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.pally.AD.ADR == true then
					Print_Raid("%s is active again!")
				end
				if RSA.db.profile.pally.AD.ADC == true then
					Print_Channel("%s is active again!")
				end
				if RSA.db.profile.pally.AD.ADS == true then
					Print_Self("%s is active again!")
				end		
			end
			
			if spellID == 31821 and dest == pName then -- Aura Mastery
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.pally.AM.AMR == true then
					Print_Raid("%s has ended!")
				end
				if RSA.db.profile.pally.AM.AMC == true then
					Print_Channel("%s has ended!")
				end
				if RSA.db.profile.pally.AM.AMS == true then
					Print_Self("%s has ended!")
				end		
			end			
			
			--[[ Start Priest Spells ]]--
--[[			if spellID == 47788 then -- Guardian Spirit
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.priest.GS.GSR == true then
					Print_Raid("%s on " .. dest .. " has ended!")
				end
				if RSA.db.profile.priest.GS.GSC == true then
					Print_Channel("%s on " .. dest .. " has ended!")
				end
				if RSA.db.profile.priest.GS.GSS == true then
					Print_Self("%s on " .. dest .. " has ended!")
				end
			end

			if spellID == 33206 then -- Pain Suppression
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.priest.PS.PSR == true then
					Print_Raid("%s on " .. dest .. " has ended!")
				end
				if RSA.db.profile.priest.PS.PSC == true then
					Print_Channel("%s on " .. dest .. " has ended!")
				end
				if RSA.db.profile.priest.PS.PSS == true then
					Print_Self("%s on " .. dest .. " has ended!")
				end			
			end

			if spellID == 64843 then -- Divine Hymn
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.priest.DH.DHR == true then
					Print_Raid("%s has ended!")
				end
				if RSA.db.profile.priest.DH.DHC == true then
					Print_Channel("%s has ended!")
				end
				if RSA.db.profile.priest.DH.DHS == true then
					Print_Self("%s has ended!")
				end	
			end

			if spellID == 64901 then -- Hymn of Hope
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.priest.HoH.HoHR == true then
					Print_Raid("%s has ended!")
				end
				if RSA.db.profile.priest.HoH.HoHC == true then
					Print_Channel("%s has ended!")
				end
				if RSA.db.profile.priest.HoH.HoHS == true then
					Print_Self("%s has ended!")
				end				
			end				
]]--		
		
		
		elseif event == "SPELL_AURA_APPLIED" then -- Start check for procs that aren't cast but apply auras, such as Ardent Defender.
		
			--[[ Start Paladin Spells ]]--
			if RSA.db.profile.pally.RF.RFOn == true then -- Righteous Fury auto recast and announce.
				if spellID == 25780 and dest == pName then
					bindingcheck()
					RFWarner:SetScript("OnUpdate", nil)
					Print_Self("Righteous Fury has been recast.")
					if RSA.db.profile.pally.RF.RFSW == true then
						SetBinding("MOUSEWHEELUP", RSA.db.profile.oldwheelup)
						SetBinding("MOUSEWHEELDOWN", RSA.db.profile.oldwheeldown)
					end
				end
			end
			
			if spellID == 66233 and dest == pName then -- Ardent Defender
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.pally.AD.ADR == true then
					Print_Raid("%s has saved my life, you fail healers!")
				end
				if RSA.db.profile.pally.AD.ADC == true then
					Print_Channel("%s has saved my life, you fail healers!")
				end
				if RSA.db.profile.pally.AD.ADS == true then
					Print_Self("%s has saved my life, you fail healers!")
				end		
			end

			if spellID == 31790 and dest ~= pName and RSA.db.profile.pally.RD.RDSuccess == true then -- Righteous Defense
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.pally.RD.RDR == true then
					Print_Raid("Taunted " .. dest .. "!")
				end
				if RSA.db.profile.pally.RD.RDC == true then
					Print_Channel("Taunted " .. dest .. "!")
				end
				if RSA.db.profile.pally.RD.RDS == true then
					Print_Self("Taunted " .. dest .. "!")
				end		
			end

			if spellID == 62124 and dest ~= pName and RSA.db.profile.pally.HoR.HoRSuccess == true then -- Hand of Reckoning
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.pally.HoR.HoRR == true then
					Print_Raid("Taunted " .. dest .. "!")
				end
				if RSA.db.profile.pally.HoR.HoRC == true then
					Print_Channel("Taunted " .. dest .. "!")
				end
				if RSA.db.profile.pally.HoR.HoRS == true then
					Print_Self("Taunted " .. dest .. "!")
				end		
			end				
			
			--[[ Start Priest Spells ]]--
--[[			if spellID == 47788 then -- Guardian Spirit
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.priest.GS.GSR == true then
					Print_Raid("%s on " .. dest .. "!")
				end
				if RSA.db.profile.priest.GS.GSC == true then
					Print_Channel("%s on " .. dest .. "!")
				end
				if RSA.db.profile.priest.GS.GSS == true then
					Print_Self("%s on " .. dest .. "!")
				end
				if RSA.db.profile.priest.GS.GSW == true and dest ~= pName then
					Print_Whisper("%s on You!", dest)
				end	
			end

			if spellID == 33206 then -- Pain Suppression
				spellinfo = GetSpellInfo(spellID)
				if RSA.db.profile.priest.PS.PSR == true then
					Print_Raid("%s on " .. dest .. "!")
				end
				if RSA.db.profile.priest.PS.PSC == true then
					Print_Channel("%s on " .. dest .. "!")
				end
				if RSA.db.profile.priest.PS.PSS == true then
					Print_Self("%s on " .. dest .. "!")
				end
				if RSA.db.profile.priest.PS.PSW == true and dest ~= pName then
					Print_Whisper("%s on You!", dest)
				end	
			end
			
			]]--

		elseif event == "SPELL_MISSED" then -- We only need this for things like taunt resists.
			if missType ~= "IMMUNE" then	
			
				if spellID == 31790 and dest ~= pName and RSA.db.profile.pally.RD.RDResist == true then -- Righteous Defense
					spellinfo = GetSpellInfo(spellID)
					if RSA.db.profile.pally.RD.RDR == true then
						Print_Raid(dest .. " has resisted my taunt!")
					end
					if RSA.db.profile.pally.RD.RDC == true then
						Print_Channel(dest .. " has resisted my taunt!")
					end
					if RSA.db.profile.pally.RD.RDS == true then
						Print_Self(dest .. " has resisted my taunt!")
					end		
				end
				
				if spellID == 62124 and dest ~= pName and RSA.db.profile.pally.HoR.HoRResist == true then -- Hand of Reckoning
					spellinfo = GetSpellInfo(spellID)
					if RSA.db.profile.pally.HoR.HoRR == true then
						Print_Raid(dest .. " has resisted my taunt!")
					end
					if RSA.db.profile.pally.HoR.HoRC == true then
						Print_Channel(dest .. " has resisted my taunt!")
					end
					if RSA.db.profile.pally.HoR.HoRS == true then
						Print_Self(dest .. " has resisted my taunt!")
					end		
				end

				
			elseif missType ==	"IMMUNE" then
				if spellID == 31790 and dest ~= pName and RSA.db.profile.pally.RD.RDResist == true then -- Righteous Defense
					spellinfo = GetSpellInfo(spellID)
					if RSA.db.profile.pally.RD.RDR == true then
						Print_Raid(dest .. " is immune to my taunt!")
					end
					if RSA.db.profile.pally.RD.RDC == true then
						Print_Channel(dest .. " is immune to my taunt!")
					end
					if RSA.db.profile.pally.RD.RDS == true then
						Print_Self(dest .. " is immune to my taunt!")
					end		
				end
				
				if spellID == 62124 and dest ~= pName and RSA.db.profile.pally.HoR.HoRResist == true then -- Hand of Reckoning
					spellinfo = GetSpellInfo(spellID)
					if RSA.db.profile.pally.HoR.HoRR == true then
						Print_Raid(dest .. " is immune to my taunt!")
					end
					if RSA.db.profile.pally.HoR.HoRC == true then
						Print_Channel(dest .. " is immune to my taunt!")
					end
					if RSA.db.profile.pally.HoR.HoRS == true then
						Print_Self(dest .. " is immune to my taunt!")
					end
				end
				
				
			end		
		end -- End of the If checking which event is fired.		
	end -- Ends if source is player.
end) -- Final end for the OnEvent function.




spells:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")